import _extends from "@babel/runtime/helpers/extends";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["className", "selectedClassName"],
    _excluded2 = ["value", "optionClick", "noOptionsTitle", "filterValue", "filterValueText", "selectedValues", "OptionProps"],
    _excluded3 = ["sortTitle", "onFilter", "onSort", "sortDirection", "value", "placeholder", "id", "sortUpIcon", "sortDownIcon"],
    _excluded4 = ["className", "error"],
    _excluded5 = ["className"];

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import DualListSelectCommon from '@data-driven-forms/common/dual-list-select';
import Button from "semantic-ui-react/dist/es/elements/Button/Button.js";
import Grid from "semantic-ui-react/dist/es/collections/Grid/Grid.js";
import GridColumn from "semantic-ui-react/dist/es/collections/Grid/GridColumn.js";
import Input from "semantic-ui-react/dist/es/elements/Input/Input.js";
import Segment from "semantic-ui-react/dist/es/elements/Segment/Segment.js";
import Header from "semantic-ui-react/dist/es/elements/Header/Header.js";
import FormField from '../form-field';
import { createUseStyles } from "react-jss/dist/react-jss.esm.js";
import clsx from 'clsx';
import FormFieldGrid from '../form-field-grid';
import { validationError, validationWarning } from '../helpers/helpers';
var useListStyles = createUseStyles({
  root: {
    padding: '.25em'
  },
  selected: {
    color: 'white',
    background: '#2185d0'
  }
});

var List = function List(_ref) {
  var _ref$value = _ref.value,
      value = _ref$value === void 0 ? [] : _ref$value,
      optionClick = _ref.optionClick,
      noOptionsTitle = _ref.noOptionsTitle,
      filterValue = _ref.filterValue,
      filterValueText = _ref.filterValueText,
      selectedValues = _ref.selectedValues,
      _ref$OptionProps = _ref.OptionProps;
  _ref$OptionProps = _ref$OptionProps === void 0 ? {} : _ref$OptionProps;

  var className = _ref$OptionProps.className,
      selectedClassName = _ref$OptionProps.selectedClassName,
      OptionProps = _objectWithoutProperties(_ref$OptionProps, _excluded),
      rest = _objectWithoutProperties(_ref, _excluded2);

  var classes = useListStyles();
  return /*#__PURE__*/React.createElement(Segment, rest, value.length < 1 && /*#__PURE__*/React.createElement("div", null, filterValue ? filterValueText : noOptionsTitle), value.length > 0 && value.map(function (_ref2) {
    var _clsx;

    var value = _ref2.value,
        label = _ref2.label;
    return /*#__PURE__*/React.createElement("div", _extends({
      className: clsx(classes.root, className, (_clsx = {}, _defineProperty(_clsx, classes.selected, selectedValues.includes(value)), _defineProperty(_clsx, selectedClassName, selectedValues.includes(value)), _clsx))
    }, OptionProps, {
      onClick: function onClick(e) {
        return optionClick(e, value);
      },
      key: value,
      value: value
    }), label);
  }));
};

List.propTypes = {
  value: PropTypes.arrayOf(PropTypes.shape({
    value: PropTypes.string.isRequired,
    label: PropTypes.string.isRequired
  })),
  optionClick: PropTypes.func.isRequired,
  noOptionsTitle: PropTypes.node,
  filterValue: PropTypes.string,
  filterValueText: PropTypes.node,
  selectedValues: PropTypes.array,
  OptionProps: PropTypes.shape({
    className: PropTypes.string,
    selectedClassName: PropTypes.string
  })
};

var Toolbar = function Toolbar(_ref3) {
  var sortTitle = _ref3.sortTitle,
      onFilter = _ref3.onFilter,
      onSort = _ref3.onSort,
      sortDirection = _ref3.sortDirection,
      value = _ref3.value,
      placeholder = _ref3.placeholder,
      id = _ref3.id,
      _ref3$sortUpIcon = _ref3.sortUpIcon,
      sortUpIcon = _ref3$sortUpIcon === void 0 ? 'sort amount up' : _ref3$sortUpIcon,
      _ref3$sortDownIcon = _ref3.sortDownIcon,
      sortDownIcon = _ref3$sortDownIcon === void 0 ? 'sort amount down' : _ref3$sortDownIcon,
      rest = _objectWithoutProperties(_ref3, _excluded3);

  return /*#__PURE__*/React.createElement("div", {
    id: id
  }, /*#__PURE__*/React.createElement(Input, _extends({
    name: "filterOptions",
    id: "filterOptions",
    type: "search",
    icon: "search",
    iconPosition: "left",
    "aria-label": placeholder,
    onChange: function onChange(_ref4) {
      var value = _ref4.target.value;
      return onFilter(value);
    },
    placeholder: placeholder,
    action: /*#__PURE__*/React.createElement(Button, {
      type: "button",
      onClick: onSort,
      title: sortTitle,
      icon: sortDirection ? sortUpIcon : sortDownIcon
    })
  }, rest)));
};

Toolbar.propTypes = {
  sortTitle: PropTypes.node,
  onFilter: PropTypes.func.isRequired,
  onSort: PropTypes.func.isRequired,
  sortDirection: PropTypes.bool,
  value: PropTypes.string,
  placeholder: PropTypes.string,
  id: PropTypes.string,
  sortUpIcon: PropTypes.string,
  sortDownIcon: PropTypes.string
};
var useDualListStyles = createUseStyles({
  dualListButtons: {
    display: 'flex !important',
    alignItems: 'flex-start',
    justifyContent: 'center'
  },
  transferButton: {
    display: 'block !important',
    margin: 'auto !important'
  },
  formField: {
    '&>label': {
      display: 'inline-block !important'
    }
  },
  '@media screen and (max-width: 767px)': {
    transferButton: {
      transform: 'rotate(90deg)'
    }
  }
});

var DualList = function DualList(_ref5) {
  var meta = _ref5.meta,
      input = _ref5.input,
      label = _ref5.label,
      isRequired = _ref5.isRequired,
      helperText = _ref5.helperText,
      state = _ref5.state,
      id = _ref5.id,
      sortOptions = _ref5.sortOptions,
      filterOptions = _ref5.filterOptions,
      handleOptionsClick = _ref5.handleOptionsClick,
      leftValues = _ref5.leftValues,
      handleMoveRight = _ref5.handleMoveRight,
      handleMoveLeft = _ref5.handleMoveLeft,
      handleClearLeftValues = _ref5.handleClearLeftValues,
      handleClearRightValues = _ref5.handleClearRightValues,
      sortValues = _ref5.sortValues,
      filterValues = _ref5.filterValues,
      rightValues = _ref5.rightValues,
      handleValuesClick = _ref5.handleValuesClick,
      validateOnMount = _ref5.validateOnMount,
      _ref5$LabelProps = _ref5.LabelProps;
  _ref5$LabelProps = _ref5$LabelProps === void 0 ? {} : _ref5$LabelProps;

  var labelClassName = _ref5$LabelProps.className,
      labelError = _ref5$LabelProps.error,
      LabelProps = _objectWithoutProperties(_ref5$LabelProps, _excluded4),
      _ref5$ButtonGridProps = _ref5.ButtonGridProps;

  _ref5$ButtonGridProps = _ref5$ButtonGridProps === void 0 ? {} : _ref5$ButtonGridProps;

  var buttonGridClassName = _ref5$ButtonGridProps.className,
      ButtonGridProps = _objectWithoutProperties(_ref5$ButtonGridProps, _excluded5),
      _ref5$leftTitle = _ref5.leftTitle,
      leftTitle = _ref5$leftTitle === void 0 ? 'Options' : _ref5$leftTitle,
      _ref5$rightTitle = _ref5.rightTitle,
      rightTitle = _ref5$rightTitle === void 0 ? 'Selected' : _ref5$rightTitle,
      _ref5$moveLeftTitle = _ref5.moveLeftTitle,
      moveLeftTitle = _ref5$moveLeftTitle === void 0 ? 'Move selected to left' : _ref5$moveLeftTitle,
      _ref5$moveRightTitle = _ref5.moveRightTitle,
      moveRightTitle = _ref5$moveRightTitle === void 0 ? 'Move selected to right' : _ref5$moveRightTitle,
      _ref5$moveAllRightTit = _ref5.moveAllRightTitle,
      moveAllRightTitle = _ref5$moveAllRightTit === void 0 ? 'Move all to right' : _ref5$moveAllRightTit,
      _ref5$moveAllLeftTitl = _ref5.moveAllLeftTitle,
      moveAllLeftTitle = _ref5$moveAllLeftTitl === void 0 ? 'Move all to left' : _ref5$moveAllLeftTitl,
      _ref5$noOptionsTitle = _ref5.noOptionsTitle,
      noOptionsTitle = _ref5$noOptionsTitle === void 0 ? 'No available options' : _ref5$noOptionsTitle,
      _ref5$noValueTitle = _ref5.noValueTitle,
      noValueTitle = _ref5$noValueTitle === void 0 ? 'No selected' : _ref5$noValueTitle,
      _ref5$filterOptionsTi = _ref5.filterOptionsTitle,
      filterOptionsTitle = _ref5$filterOptionsTi === void 0 ? 'Filter options' : _ref5$filterOptionsTi,
      _ref5$filterValueTitl = _ref5.filterValueTitle,
      filterValueTitle = _ref5$filterValueTitl === void 0 ? 'Filter selected value' : _ref5$filterValueTitl,
      _ref5$filterOptionsTe = _ref5.filterOptionsText,
      filterOptionsText = _ref5$filterOptionsTe === void 0 ? 'Remove your filter to see all options' : _ref5$filterOptionsTe,
      _ref5$filterValueText = _ref5.filterValueText,
      filterValueText = _ref5$filterValueText === void 0 ? 'Remove your filter to see all selected' : _ref5$filterValueText,
      _ref5$leftSortTitle = _ref5.leftSortTitle,
      leftSortTitle = _ref5$leftSortTitle === void 0 ? 'Sort options' : _ref5$leftSortTitle,
      _ref5$rightSortTitle = _ref5.rightSortTitle,
      rightSortTitle = _ref5$rightSortTitle === void 0 ? 'Sort value' : _ref5$rightSortTitle,
      _ref5$allToLeft = _ref5.allToLeft,
      allToLeft = _ref5$allToLeft === void 0 ? true : _ref5$allToLeft,
      _ref5$allToRight = _ref5.allToRight,
      allToRight = _ref5$allToRight === void 0 ? true : _ref5$allToRight,
      _ref5$OptionsListProp = _ref5.OptionsListProps,
      OptionsListProps = _ref5$OptionsListProp === void 0 ? {} : _ref5$OptionsListProp,
      _ref5$OptionProps = _ref5.OptionProps,
      OptionProps = _ref5$OptionProps === void 0 ? {} : _ref5$OptionProps,
      _ref5$ToolbarProps = _ref5.ToolbarProps,
      ToolbarProps = _ref5$ToolbarProps === void 0 ? {} : _ref5$ToolbarProps,
      _ref5$RightButtonProp = _ref5.RightButtonProps,
      RightButtonProps = _ref5$RightButtonProp === void 0 ? {} : _ref5$RightButtonProp,
      _ref5$DoubleRightButt = _ref5.DoubleRightButtonProps,
      DoubleRightButtonProps = _ref5$DoubleRightButt === void 0 ? {} : _ref5$DoubleRightButt,
      _ref5$LeftButtonProps = _ref5.LeftButtonProps,
      LeftButtonProps = _ref5$LeftButtonProps === void 0 ? {} : _ref5$LeftButtonProps,
      _ref5$DoubleLeftButto = _ref5.DoubleLeftButtonProps,
      DoubleLeftButtonProps = _ref5$DoubleLeftButto === void 0 ? {} : _ref5$DoubleLeftButto,
      _ref5$OptionsHeaderPr = _ref5.OptionsHeaderProps,
      OptionsHeaderProps = _ref5$OptionsHeaderPr === void 0 ? {} : _ref5$OptionsHeaderPr,
      _ref5$ValuesHeaderPro = _ref5.ValuesHeaderProps,
      ValuesHeaderProps = _ref5$ValuesHeaderPro === void 0 ? {} : _ref5$ValuesHeaderPro,
      _ref5$HelperTextProps = _ref5.HelperTextProps,
      HelperTextProps = _ref5$HelperTextProps === void 0 ? {} : _ref5$HelperTextProps,
      _ref5$FormFieldGridPr = _ref5.FormFieldGridProps,
      FormFieldGridProps = _ref5$FormFieldGridPr === void 0 ? {} : _ref5$FormFieldGridPr;

  var invalid = validationError(meta, validateOnMount);
  var classes = useDualListStyles();
  return /*#__PURE__*/React.createElement(FormFieldGrid, _extends({
    helperText: validationWarning(meta, validateOnMount) || helperText,
    HelperTextProps: HelperTextProps
  }, FormFieldGridProps), /*#__PURE__*/React.createElement(FormField, _extends({
    label: label,
    required: isRequired,
    error: invalid && _objectSpread({
      content: meta.error || meta.submitError,
      pointing: 'left'
    }, labelError),
    id: id || input.name,
    control: function control(props) {
      return null;
    }
  }, LabelProps, {
    className: clsx(classes.formField, labelClassName)
  })), /*#__PURE__*/React.createElement(Grid, {
    key: "0"
  }, /*#__PURE__*/React.createElement(GridColumn, {
    mobile: 16,
    tablet: 7,
    computer: 7
  }, /*#__PURE__*/React.createElement(Grid, null, /*#__PURE__*/React.createElement(GridColumn, {
    mobile: 16,
    tablet: 16
  }, /*#__PURE__*/React.createElement(Header, _extends({
    sub: true
  }, OptionsHeaderProps), leftTitle)), /*#__PURE__*/React.createElement(GridColumn, {
    mobile: 16,
    tablet: 16
  }, /*#__PURE__*/React.createElement(Toolbar, _extends({
    sortDirection: state.sortLeftDesc,
    onSort: sortOptions,
    onFilter: filterOptions,
    value: state.filterOptions,
    placeholder: filterOptionsTitle,
    id: "".concat(input.name, "-options-toolbar"),
    sortTitle: leftSortTitle
  }, ToolbarProps))), /*#__PURE__*/React.createElement(GridColumn, {
    mobile: 16,
    tablet: 16
  }, /*#__PURE__*/React.createElement(List, _extends({}, OptionsListProps, {
    OptionProps: OptionProps,
    optionClick: handleOptionsClick,
    value: leftValues,
    noOptionsTitle: noOptionsTitle,
    filterValue: state.filterOptions,
    filterValueText: filterOptionsText,
    selectedValues: state.selectedLeftValues
  }))))), /*#__PURE__*/React.createElement(GridColumn, _extends({
    className: clsx(classes.dualListButtons, buttonGridClassName)
  }, ButtonGridProps, {
    mobile: 16,
    tablet: 2,
    computer: 2
  }), /*#__PURE__*/React.createElement(Grid, null, /*#__PURE__*/React.createElement(GridColumn, {
    tablet: 16,
    mobile: 4
  }, /*#__PURE__*/React.createElement(Button, _extends({
    className: classes.transferButton,
    icon: "angle right"
  }, RightButtonProps, {
    type: "button",
    disabled: leftValues.length === 0,
    onClick: handleMoveRight,
    title: moveRightTitle
  }))), allToRight && /*#__PURE__*/React.createElement(GridColumn, {
    tablet: 16,
    mobile: 4
  }, /*#__PURE__*/React.createElement(Button, _extends({
    className: classes.transferButton,
    icon: "angle double right"
  }, DoubleRightButtonProps, {
    type: "button",
    disabled: leftValues.length === 0,
    onClick: handleClearLeftValues,
    title: moveAllRightTitle
  }))), allToLeft && /*#__PURE__*/React.createElement(GridColumn, {
    tablet: 16,
    mobile: 4
  }, /*#__PURE__*/React.createElement(Button, _extends({
    className: classes.transferButton,
    icon: "angle double left"
  }, LeftButtonProps, {
    type: "button",
    disabled: rightValues.length === 0,
    onClick: handleClearRightValues,
    title: moveAllLeftTitle
  }))), /*#__PURE__*/React.createElement(GridColumn, {
    tablet: 16,
    mobile: 4
  }, /*#__PURE__*/React.createElement(Button, _extends({
    className: classes.transferButton,
    icon: "angle left"
  }, DoubleLeftButtonProps, {
    type: "button",
    disabled: rightValues.length === 0,
    onClick: handleMoveLeft,
    title: moveLeftTitle
  }))))), /*#__PURE__*/React.createElement(GridColumn, {
    mobile: 16,
    tablet: 7,
    computer: 7
  }, /*#__PURE__*/React.createElement(Grid, null, /*#__PURE__*/React.createElement(GridColumn, {
    tablet: 16
  }, /*#__PURE__*/React.createElement(Header, _extends({
    sub: true
  }, ValuesHeaderProps), rightTitle)), /*#__PURE__*/React.createElement(GridColumn, {
    tablet: 16
  }, /*#__PURE__*/React.createElement(Toolbar, _extends({
    sortDirection: state.sortRightDesc,
    onSort: sortValues,
    onFilter: filterValues,
    value: state.filterValue,
    placeholder: filterValueTitle,
    id: "".concat(input.name, "-value-toolbar"),
    sortTitle: rightSortTitle
  }, ToolbarProps))), /*#__PURE__*/React.createElement(GridColumn, {
    tablet: 16
  }, /*#__PURE__*/React.createElement(List, _extends({}, OptionsListProps, {
    OptionProps: OptionProps,
    optionClick: handleValuesClick,
    value: rightValues,
    noOptionsTitle: noValueTitle,
    filterValue: state.filterValue,
    filterValueText: filterValueText,
    selectedValues: state.selectedRightValues
  })))))));
};

DualList.propTypes = {
  leftTitle: PropTypes.node,
  rightTitle: PropTypes.node,
  moveLeftTitle: PropTypes.node,
  moveRightTitle: PropTypes.node,
  allToLeft: PropTypes.bool,
  allToRight: PropTypes.bool,
  moveAllLeftTitle: PropTypes.node,
  moveAllRightTitle: PropTypes.node,
  label: PropTypes.node,
  isRequired: PropTypes.bool,
  helperText: PropTypes.node,
  noValueTitle: PropTypes.node,
  noOptionsTitle: PropTypes.node,
  filterOptionsTitle: PropTypes.node,
  filterValueTitle: PropTypes.node,
  filterValueText: PropTypes.node,
  filterOptionsText: PropTypes.node,
  id: PropTypes.string,
  input: PropTypes.shape({
    name: PropTypes.string.isRequired
  }),
  meta: PropTypes.any,
  state: PropTypes.object,
  sortOptions: PropTypes.func,
  filterOptions: PropTypes.func,
  handleOptionsClick: PropTypes.func,
  leftValues: PropTypes.array,
  handleMoveRight: PropTypes.func,
  handleMoveLeft: PropTypes.func,
  handleClearLeftValues: PropTypes.func,
  handleClearRightValues: PropTypes.func,
  sortValues: PropTypes.func,
  filterValues: PropTypes.func,
  rightValues: PropTypes.array,
  handleValuesClick: PropTypes.func,
  validateOnMount: PropTypes.bool,
  leftSortTitle: PropTypes.node,
  rightSortTitle: PropTypes.node,

  /** Sub components customization API */
  OptionsListProps: PropTypes.object,
  OptionProps: PropTypes.object,
  LabelProps: PropTypes.shape({
    error: PropTypes.object,
    className: PropTypes.string
  }),
  ToolbarProps: PropTypes.object,
  ButtonGridProps: PropTypes.shape({
    className: PropTypes.string
  }),
  RightButtonProps: PropTypes.object,
  DoubleRightButtonProps: PropTypes.object,
  LeftButtonProps: PropTypes.object,
  DoubleLeftButtonProps: PropTypes.object,
  OptionsHeaderProps: PropTypes.object,
  ValuesHeaderProps: PropTypes.object,
  HelperTextProps: PropTypes.object,
  FormFieldGridProps: PropTypes.object
};

var DualListSelectWrapper = function DualListSelectWrapper(props) {
  return /*#__PURE__*/React.createElement(DualListSelectCommon, _extends({}, props, {
    DualListSelect: DualList
  }));
};

export default DualListSelectWrapper;